require 'inifile'

module Fpmache
  # Process single INI file and return section contents
  class File
    attr_accessor :contents, :inifile
    def initialize(inifile)
      @inifile = inifile
      @contents = {}
    end

    # Public - Read the INI file and return the processed Hash. Usually, there
    # would be one section per file for PHP-FPM configuraiton file
    #
    # Returns Hash
    def read
      ini = IniFile.load(@inifile)

      section = process_sections(ini)
      ini[section]
    end

    private

    # Private - Process the returned Object and list out sections, we are
    # expecting one section
    #
    # ini - Object procesed Ini file
    #
    # Returns String
    def process_sections(ini)
      if ini.sections.length == 1
        ini.sections[0]
      else
        throw Exception('More than one section found in INI file')
      end
    end
  end
end
